pub fn parse_elves(input: &String) -> Vec<u32> {
    let lines = input.lines();
    let mut elves = vec![0];
    for line in lines {
        if line.is_empty() {
            elves.push(0);
            continue;
        }

        let calories: u32 = line.parse().expect("Wanted a number");
        let prev_calories = elves.pop().unwrap();
        elves.push(prev_calories + calories);
    }

    elves
}
